Index: libabac/abac_verifier.c
===================================================================
--- libabac/abac_verifier.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_verifier.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -19,34 +19,27 @@
 extern abac_role_t *abac_get_yap_head_role();
 extern abac_role_t *abac_get_yap_tail_role();
+extern abac_oset_t *abac_get_yap_head_oset();
+extern abac_oset_t *abac_get_yap_tail_oset();
+extern int abac_get_yap_is_oset();
 extern abac_list_t *abac_get_yap_clauses();
+extern char* abac_decode_string(char *);
 
 /* keeping this a fixed enum is to have tighter control of
    what are acceptabletypes of keyid are we allowing */
 enum keyidtype {
-    KEYID = 1
+    e_KEYID = 1
 };
 /* keyidname[keyidtype] */
-static const char *const keyidname[] =
+static char * const keyidname[] =
 {
   "badidtype", "keyid", 0
 };
+
+enum credtype {
+   e_CREDTYPE_ROLE =1,
+   e_CREDTYPE_OSET =2
+};
+
 static int keyidname_cnt=1;
-
-enum dtermtype {
-    INT = 1,
-    URN = 2,
-    FLOAT = 3,
-    BOOLEAN = 4,
-    STRING = 5,
-    TIME = 6,
-    PRINCIPAL = 7,
-    ANONYMOUS = 8
-};
-/* dtermname[dtermtype] */
-static const char *const dtermname[] =
-{
-  "baddterm", "int", "urn", "float", "boolean", "string", "time" , "principal", "anonymous", 0
-};
-static int dtermname_cnt=8;
 
 struct _abac_id_cert_t {
@@ -60,8 +53,9 @@
 };
 
-
+/* can store either role or oset */
 struct _abac_credential_t {
-    abac_role_t *head;
-    abac_role_t *tail;
+    int type;
+    void *head;
+    void *tail;
     certificate_t *cert;
     certificate_t *issuer;
@@ -83,18 +77,27 @@
 static int debug=0;
 static void check_id_cert(abac_id_cert_t *id_cert);
-extern void abac_print_role_string_with_condition(abac_role_t *role);
+extern void abac_print_role_string_with_condition(abac_role_t *role, FILE*);
 
 //
-void abac_print_cred_info(abac_credential_t *cred)
-{
+void abac_print_cred_info(abac_credential_t *cred, FILE *fp)
+{
+    if(fp == NULL)
+        fp=stdout;
+
     if(debug) {
-        printf("---> printing out credential info cred(%d)..\n", (int) cred);
+        fprintf(fp,"---> printing out credential info cred(%d)..\n", (int) cred);
         if(cred->head) {
-            printf("  head role(%d):\n",(int)cred->head);
-            abac_print_role_string_with_condition(cred->head);
+            fprintf(fp,"  head cred(%d):\n",(int)cred->head);
+            if(cred->type == e_CREDTYPE_ROLE)
+               abac_print_role_string_with_condition((abac_role_t*)cred->head,fp);
+               else
+                   abac_print_oset_string_with_condition((abac_oset_t*)cred->head,fp);
         }
         if(cred->tail) {
-            printf("  tail role(%d):\n",(int)cred->tail);
-            abac_print_role_string_with_condition(cred->tail);
+            fprintf(fp,"\n  tail cred(%d):\n",(int)cred->tail);
+            if(cred->type == e_CREDTYPE_ROLE)
+                abac_print_role_string_with_condition((abac_role_t*)cred->tail,fp);
+                else
+                    abac_print_oset_string_with_condition((abac_oset_t*)cred->tail,fp);
         }
 
@@ -103,15 +106,19 @@
             char *cur=NULL;
             abac_list_foreach(clauses, cur,
-                printf("  a clause(%d):\n",(int)cur);
+                fprintf(fp,"\n  a clause(%d):\n",(int)cur);
                 if(cur)
-                    printf ("strlen(%d)loc(%d)(%s)\n", strlen(cur),(int)cur, cur);
+                    fprintf(fp,"strlen(%d)loc(%d)(%s)\n", strlen(cur),(int)cur, cur);
             );
         }
         } else {
-            printf(" ");
-            abac_print_role_string_with_condition(cred->head);
-            printf(" <- ");
-            abac_print_role_string_with_condition(cred->tail);
-            printf("\n");
+            fprintf(fp," ");
+            if(cred->type == e_CREDTYPE_ROLE)
+                abac_print_role_string_with_condition((abac_role_t *)cred->head,fp);
+                else abac_print_oset_string_with_condition((abac_oset_t *)cred->head,fp);
+            fprintf(fp," <- ");
+            if(cred->type == e_CREDTYPE_ROLE)
+                abac_print_role_string_with_condition((abac_role_t *)cred->tail,fp);
+                else abac_print_oset_string_with_condition((abac_oset_t *)cred->tail,fp);
+            fprintf(fp,"\n");
    }
 }
@@ -133,16 +140,4 @@
 {
     return keyidname[i];
-}
-
-int abac_verify_dterm_type(char *type) {
-    int i;
-
-    if (type == NULL)
-        return 0;
-
-    for (i = 1; i <= dtermname_cnt ; i++)
-        if(strcmp(type,dtermname[i])==0)
-            return i;
-    return 0;
 }
 
@@ -262,5 +257,5 @@
     id_cert->cn = cn;
     /* XXX default it to it now */
-    id_cert->type = KEYID;
+    id_cert->type = e_KEYID;
     id_cert->clause = generate_pl_type_clause(cn, id_cert->type);
 
@@ -290,5 +285,4 @@
  * Load an attribute cert as string.
  * have minimum syntax & validity check
-XXXX
  */
 static int _load_attribute_string(char* attr_string) {
@@ -333,52 +327,28 @@
 
 
-void abac_print_clauses(abac_list_t *clauses)
+void abac_print_clauses(abac_list_t *clauses, FILE *fp)
 {
     if (clauses != NULL) {
         char *cur;
         abac_list_foreach(clauses, cur,
-            if(cur)
-                printf ("a clause, %d(%s)\n", (int)cur,cur);
+            if(cur) {
+                if(fp)
+                    fprintf (fp,"a clause, %d(%s)\n", (int)cur,cur);
+                    else printf ("a clause, %d(%s)\n", (int)cur,cur);
+            }
         );
     }
 }
 
-/**
- * Load an attribute cert.
- * Returns true only if the certificate is valid and is issued by the proper
- * authority.
- */
-static int _load_attribute_cert(certificate_t *cert, abac_credential_t **cred_ret) {
-    ietf_attributes_t *attr_cert = NULL;
+static int _verify_valid_role_credential(certificate_t *cert,
+abac_credential_t **cred_ret, char *encoded_attr_string)
+{
     abac_role_t *head_role = NULL;
     abac_role_t *tail_role = NULL;
     abac_list_t *clauses=NULL;
     abac_id_cert_t *issuer;
-    char *attr_string_copy;
     int ret, i;
 
     // get the attr
-    ac_t *ac = (ac_t *)cert;
-    attr_cert = ac->get_groups(ac);
-    if (attr_cert == NULL) {
-        ret = ABAC_CERT_INVALID;
-        goto error;
-    }
-
-    char *attr_string = attr_cert->get_string(attr_cert);
-    if (attr_string == NULL) {
-        ret = ABAC_CERT_INVALID;
-        goto error;
-    }
-
-    /* call into yacc parser */
-    attr_string_copy = strdup(attr_string);
-    abac_reset_yyfptr(attr_string_copy);
-    abac_yyinit();
-    int rc=yyparse();
-    if (rc) {
-        ret = ABAC_CERT_INVALID;
-        goto error;
-    }
     head_role = abac_get_yap_head_role();
     tail_role = abac_get_yap_tail_role();
@@ -402,4 +372,5 @@
     // at this point we know we have a good attribute cert
     abac_credential_t *cred = abac_xmalloc(sizeof(abac_credential_t));
+    cred->type= e_CREDTYPE_ROLE;
     cred->head = head_role;
     cred->tail = tail_role;
@@ -413,7 +384,116 @@
     abac_str_cred_t *str_cred;
     str_cred=abac_xmalloc(sizeof(abac_str_cred_t));
-    str_cred->strid=attr_string_copy;
+    str_cred->strid=strdup(encoded_attr_string);
     str_cred->cred=cred;
     HASH_ADD_KEYPTR(hh, str_creds, str_cred->strid, strlen(str_cred->strid), str_cred);
+
+    return ABAC_CERT_SUCCESS;
+
+error:
+    if (head_role) abac_role_free(head_role);
+    if (tail_role) abac_role_free(tail_role);
+    abac_free_yap_clauses();
+
+    return ret;
+}
+
+static int _verify_valid_oset_credential(certificate_t *cert,
+abac_credential_t **cred_ret, char *encoded_attr_string)
+{
+    abac_oset_t *head_oset = NULL;
+    abac_oset_t *tail_oset = NULL;
+    abac_list_t *clauses=NULL;
+    abac_id_cert_t *issuer;
+    int ret, i;
+
+    // get the attr
+    head_oset = abac_get_yap_head_oset();
+    tail_oset = abac_get_yap_tail_oset();
+    clauses = abac_get_yap_clauses();
+
+    // get the issuer based on keyid
+    char *principalname = abac_oset_principal(head_oset);
+    HASH_FIND_STR(id_certs, principalname, issuer);
+    if (issuer == NULL) {
+        ret = ABAC_CERT_MISSING_ISSUER;
+        goto error;
+    }
+
+    // make sure the issuer's signed it
+    ret = _verify_signature(issuer->cert, cert);
+    if (!ret) {
+        set_error_code(ABAC_RT_CERT_BAD_SIG);
+        goto error;
+    }
+
+    // at this point we know we have a good attribute cert
+    abac_credential_t *cred = abac_xmalloc(sizeof(abac_credential_t));
+    cred->type= e_CREDTYPE_OSET;
+    cred->head = head_oset;
+    cred->tail = tail_oset;
+    cred->cert = cert;
+    cred->issuer = issuer->cert->get_ref(issuer->cert);
+    cred->clauses = clauses;
+    cred->refcount = 1;
+    *cred_ret = cred;
+
+    // success, add the key to the map of certificates
+    abac_str_cred_t *str_cred;
+    str_cred=abac_xmalloc(sizeof(abac_str_cred_t));
+    str_cred->strid=strdup(encoded_attr_string);
+    str_cred->cred=cred;
+    HASH_ADD_KEYPTR(hh, str_creds, str_cred->strid, strlen(str_cred->strid), str_cred);
+
+    return ABAC_CERT_SUCCESS;
+
+error:
+    if (head_oset) abac_oset_free(head_oset);
+    if (tail_oset) abac_oset_free(tail_oset);
+    abac_free_yap_clauses();
+
+    return ret;
+}
+/**
+ * Load an attribute cert.
+ * Returns true only if the certificate is valid and is issued by the proper
+ * authority.
+ */
+static int _load_attribute_cert(certificate_t *cert, abac_credential_t **cred_ret) {
+    ietf_attributes_t *attr_cert = NULL;
+    abac_id_cert_t *issuer;
+    int ret, i;
+
+    // get the attr
+    ac_t *ac = (ac_t *)cert;
+    attr_cert = ac->get_groups(ac);
+    if (attr_cert == NULL) {
+        ret = ABAC_CERT_INVALID;
+        goto error;
+    }
+
+    char *encoded_attr_string=attr_cert->get_string(attr_cert);
+    char *attr_string = abac_decode_string(encoded_attr_string);
+    if(debug)
+         printf("string to be yyparse..(%s)\n",attr_string);
+
+    if (attr_string == NULL) {
+        ret = ABAC_CERT_INVALID;
+        goto error;
+    }
+
+    /* call into yacc parser */
+    abac_reset_yyfptr(attr_string);
+    abac_yyinit();
+    int rc=yyparse();
+    if (rc) {
+        ret = ABAC_CERT_INVALID;
+        goto error;
+    }
+
+    if(abac_get_yap_is_oset()) {
+        ret=_verify_valid_oset_credential(cert,cred_ret,encoded_attr_string);
+        } else {
+            ret=_verify_valid_role_credential(cert,cred_ret,encoded_attr_string);
+    }
 
     // free up some crap
@@ -425,9 +505,4 @@
     if (cert) cert->destroy(cert);
     if (attr_cert) attr_cert->destroy(attr_cert);
-    if (head_role) abac_role_free(head_role);
-    if (tail_role) abac_role_free(tail_role);
-    if (attr_string_copy) free(attr_string_copy);
-    abac_free_yap_clauses();
-
     return ret;
 }
@@ -490,18 +565,4 @@
 
 /**
- * Return the head role.
- */
-abac_role_t *abac_credential_head(abac_credential_t *cred) {
-    return cred->head;
-}
-
-/**
- * Return the tail role.
- */
-abac_role_t *abac_credential_tail(abac_credential_t *cred) {
-    return cred->tail;
-}
-
-/**
  * Return the encoding of the attribute cert.
  */
@@ -571,6 +632,11 @@
         return;
 
-    abac_role_free(cred->head);
-    abac_role_free(cred->tail);
+    if(cred->type == e_CREDTYPE_ROLE) {
+        abac_role_free((abac_role_t *)cred->head);
+        abac_role_free((abac_role_t *)cred->tail);
+        } else {
+            abac_oset_free((abac_oset_t *)cred->head);
+            abac_oset_free((abac_oset_t *)cred->tail);
+    }
     cred->cert->destroy(cred->cert);
     cred->issuer->destroy(cred->issuer); // reference counted
@@ -607,2 +673,9 @@
 }
 
+/* retrieve the cn that is associated with the principal of this oset */
+char *abac_cn_with_oset(abac_oset_t *oset) {
+
+    char *principal = abac_oset_principal(oset);
+    return abac_cn_with_sha(principal);
+}
+
Index: libabac/options.c
===================================================================
--- libabac/options.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/options.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -12,5 +12,9 @@
         "        --keystore <keystore> \\\n"
         "        --role <keyid.role> --principal <keyid>\n"
-        "    loads the keystore and runs the query role <-?- principal\n",
+        "        --oset <keyid.oset> --object <otype>\n"
+        "    loads the keystore and runs the query role <-?- principal\\\n"
+        "                                the query oset <-?- object\\\n"
+        "        --dump <file> \n"
+        "    extracts all credentials from the prolog db\n",
         name
     );
@@ -22,8 +26,14 @@
 #define OPT_ROLE        2
 #define OPT_PRINCIPAL   3
+#define OPT_DUMP        4
+#define OPT_OSET        5
+#define OPT_OBJECT      6
     struct option options[] = {
         { "keystore",   1, 0, OPT_KEYSTORE  },
         { "role",       1, 0, OPT_ROLE      },
         { "principal",  1, 0, OPT_PRINCIPAL },
+        { "dump",       1, 0, OPT_DUMP },
+        { "oset",       1, 0, OPT_OSET },
+        { "object",     1, 0, OPT_OBJECT },
         { 0 },
     };
@@ -44,4 +54,13 @@
                 opts->principal = strdup(optarg);
                 break;
+            case OPT_DUMP:
+                opts->filename = strdup(optarg);
+                break;
+            case OPT_OSET:
+                opts->oset = strdup(optarg);
+                break;
+            case OPT_OBJECT:
+                opts->object = strdup(optarg);
+                break;
 
             default:
@@ -50,5 +69,9 @@
     }
 
-    if (!(opts->keystore && opts->role && opts->principal))
+    if (!(opts->keystore && 
+                 ((opts->role && opts->principal && !opts->oset) ||
+                 (opts->oset && opts->principal && !opts->role) ||
+                 (opts->oset && opts->object && !opts->role) )) &&
+                         !(opts->filename))
         _usage(argv[0]);
 }
Index: libabac/options.h
===================================================================
--- libabac/options.h	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/options.h	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -10,4 +10,7 @@
     char *role;
     char *principal;
+    char *filename;
+    char *oset;
+    char *object;
 } options_t;
 
Index: libabac/prover_yap.c
===================================================================
--- libabac/prover_yap.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/prover_yap.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -2,4 +2,5 @@
 #include <err.h>
 #include <stdio.h>
+#include <assert.h>
 
 
@@ -8,9 +9,10 @@
 #include "options.h"
 
-extern void abac_print_cred_info(abac_credential_t *);
+extern void abac_print_cred_info(abac_credential_t*, FILE*);
 
 int main(int argc, char **argv) {
-    int i, success;
-    abac_credential_t *cred;
+    int i, success=0;
+    abac_credential_t *cred=NULL;
+    abac_credential_t **credentials=NULL;
 
     options_t opts = { 0, };
@@ -18,21 +20,55 @@
     abac_context_t *ctx = abac_context_new();
     abac_context_load_directory(ctx, opts.keystore);
-    abac_credential_t **credentials = abac_context_query(ctx,
-        opts.role, opts.principal,
-        &success
-    );
+
+    if(opts.filename) { 
+        credentials = abac_context_credentials(ctx);
+        FILE *fp=fopen(opts.filename,"w+");
+
+        if (credentials != NULL) {
+            for (i = 0; credentials[i] != NULL; ++i) {
+                cred = credentials[i];
+                abac_print_cred_info(cred,fp);
+            }
+            abac_context_credentials_free(credentials);
+        }
+        fclose(fp);
+        return 0;
+    }
+
+    char *query=NULL;
+    char *with=NULL;
+    if(opts.role && opts.principal) {
+        query=opts.role;
+        with=opts.principal;
+        } else {
+            if(opts.oset) {
+                query=opts.oset;
+            } else if(opts.principal) {
+                with=opts.principal;
+            } else if(opts.object) {
+                with=opts.object;
+            } else {
+                puts("XXXX eeekkk \n");
+                assert(0);
+            }
+    }
+    credentials = abac_context_query(ctx,
+                            query, with,
+                            &success);
     if (success)
         puts("prover success!!");
+        else puts("prover failed!!");
 
-    if (credentials != NULL)
+    if (credentials != NULL && success) {
         puts("credentials needed :");
         for (i = 0; credentials[i] != NULL; ++i) {
-            cred = credentials[i];
-            abac_print_cred_info(cred);
+           cred = credentials[i];
+           abac_print_cred_info(cred,NULL);
         }
-
-    abac_context_credentials_free(credentials);
+    }
+    if(credentials)
+        abac_context_credentials_free(credentials);
     abac_context_free(ctx);
-
+    
     return 0;
 }
Index: libabac/rt2.l
===================================================================
--- libabac/rt2.l	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/rt2.l	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,8 +1,18 @@
-%{
+%option stack
+%x BOOLEAN_S
+%x INTEGER_S 
+%x FLOAT_S
+%x TIME_S
+%x URN_S
+%x STRING_S
+%x KEYID_S
+%x RANGE_S
+
+%top{
 #include <stdio.h>
 #include <string.h>
 #include "rt2.h"
 
-static int debug=0;
+static int debug=1;
 
 /* with yacc */
@@ -14,4 +24,8 @@
 char INPUT_LINE[] = "usc.playground <- usc.employee.friend";
 char *yyfptr = INPUT_LINE; /* default */
+char *yyfptr_encoded=NULL;
+static void yy_push_state(int);
+static void yy_pop_state();
+extern char* abac_encode_string(char *);
 
 #undef YY_INPUT
@@ -30,10 +44,145 @@
     }
 
+}
+
+DIGIT    [0-9]
+ID	 [a-z][a-z0-9]*
+
+%%
+\.           { if(debug) fprintf(yyout, " DOT " );
+             return DOT; }
+keyid        { yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," KEYTYPE ");
+             return KEYTYPE; }
+<KEYID_S>[a-zA-Z0-9][a-zA-Z0-9]* {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," KEYID_CONSTANT ");
+             return KEYID_CONSTANT; }
+oset         { if(debug) fprintf(yyout," OSET ");
+             return OSET; }
+role         { if(debug) fprintf(yyout," ROLE ");
+             return ROLE; }
+principal    { if(debug) fprintf(yyout," PRINCIPAL ");
+             return PRINCIPAL; }
+integer      { yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(INTEGER) ");
+             return OTYPE; }
+<INTEGER_S>[0-9]+ {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(INTEGER) ");
+             return OTYPE_CONSTANT; }
+<INTEGER_S>[-][0-9]+ { 
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(INTEGER) ");
+             return OTYPE_CONSTANT; }
+boolean      { yylval.string =strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(BOOLEAN) ");
+             return OTYPE; }
+<BOOLEAN_S>true|false {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(BOOLEAN) ");
+             return OTYPE_CONSTANT; }
+<BOOLEAN_S,INTEGER_S,FLOAT_S,URN_S,STRING_S,TIME_S>[?][A-Z][_a-zA-Z0-9]* { 
+             yylval.string=strdup(yytext+1);
+             if(debug) fprintf(yyout," VARIABLE_CONSTANT(%s) ",yylval.string);
+             return VARIABLE_CONSTANT; }
+<BOOLEAN_S,INTEGER_S,FLOAT_S,URN_S,STRING_S,TIME_S>\[ { 
+             if(debug) fprintf(yyout," LSQUARE ");
+             return LSQUARE; }
+<BOOLEAN_S,INTEGER_S,FLOAT_S,URN_S,STRING_S,TIME_S>\] { 
+             if(debug) fprintf(yyout," RSQUARE ");
+             return RSQUARE; }
+<BOOLEAN_S,INTEGER_S,FLOAT_S,URN_S,STRING_S,TIME_S>\: { 
+             if(debug) fprintf(yyout," COLON ");
+             return COLON; }
+float        { yylval.string =strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(FLOAT) ");
+             return OTYPE; }
+<FLOAT_S>-[0-9]+"."[0-9]+ | 
+<FLOAT_S>[0-9]+"."[0-9]+ |
+<FLOAT_S>[0-9]+ |
+<FLOAT_S>-[0-9]+ {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(FLOAT) ");
+             return OTYPE_CONSTANT; }
+time         { yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(TIME) ");
+             return OTYPE; }
+<TIME_S>{DIGIT}{DIGIT}*"T"{DIGIT}* {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(TIME) ");
+             return OTYPE_CONSTANT; }
+urn          { yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(URN) ");
+             return OTYPE; }
+<URN_S>[']([^']|\\')*['] |
+<URN_S>["]([^"]|\")*["] {
+             yylval.string=strdup(yytext); 
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(URN)(%s) ",yylval.string);
+             return OTYPE_CONSTANT; }
+string       { yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," OTYPE(STRING) ");
+             return OTYPE; }
+<STRING_S>[']([^']|\\')*['] |
+<STRING_S>["]([^"]|\")*["] {
+             yylval.string=strdup(yytext); 
+             if(debug) fprintf(yyout," OTYPE_CONSTANT(STRING)(%s) ", yylval.string);
+             return OTYPE_CONSTANT; }
+<RANGE_S>\[ { 
+             if(debug) fprintf(yyout," LSQUARE ");
+             return LSQUARE; }
+<RANGE_S>\] { 
+             if(debug) fprintf(yyout," RSQUARE ");
+             return RSQUARE; }
+<RANGE_S>\.\. { 
+             if(debug) fprintf(yyout," DOTDOT ");
+             return DOTDOT; }
+<RANGE_S>[0-9]+ | 
+<RANGE_S>-[0-9]+ |
+<RANGE_S>[0-9]+T[0-9]+ {
+             yylval.string=strdup(yytext);
+             if(debug) fprintf(yyout," VALUE(%s) ",yylval.string);
+             return VALUE; }
+[a-zA-Z0-9][_a-zA-Z0-9]* { 
+             yylval.string=strdup(yytext); 
+             if(debug) fprintf(yyout," IDEN(%s) ", yylval.string);
+             return IDEN; }
+\<-          { if(debug) fprintf(yyout," DERIVE ");
+             return DERIVE; }
+&            { if(debug) fprintf(yyout, " AND " );
+             return AND; }
+,            { if(debug) fprintf(yyout, " COMMA ");
+             return COMMA; }
+\(           { if(debug) fprintf(yyout, " LPAREN ");
+             return LPAREN; }
+\)           { if(debug) fprintf(yyout, " RPAREN ");
+             return RPAREN; }
+\[           { if(debug) fprintf(yyout, " LSQUARE ");
+             return LSQUARE; }
+\]           { if(debug) fprintf(yyout, " RSQUARE ");
+             return RSQUARE; }
+\{           { if(debug) fprintf(yyout, " LWIGGLE ");
+             return LWIGGLE; }
+\}           { if(debug) fprintf(yyout, " RWIGGLE ");
+             return RWIGGLE; }
+\:           { if(debug) fprintf(yyout, " COLON ");
+             return COLON; }
+\?           { if(debug) fprintf(yyout, " QMARK ");
+             return QMARK; }
+\n           { /* ignore end-of-line */; }
+[ \t]+       { /* ignore whitespace */; }
+%%
+
 void abac_reset_yyfptr(char *str) {
     yyfptr=str;
+    yyfptr_encoded=abac_encode_string(str);
 }
 
 char* abac_get_yyfptr() {
     return yyfptr;
+}
+
+char *abac_get_yyfptr_encoded() {
+    return yyfptr_encoded;
 }
 
@@ -65,39 +214,68 @@
 }
 
-/* XXX need to add param's possible format and break it out from IDEN next */
-%}
-%%
-keyid                       { yylval.string=strdup(yytext);
-                              if(debug) fprintf(yyout," KEYTYPE ");
-                              return KEYTYPE; }
-role                        { if(debug) fprintf(yyout," ROLE ");
-                              return ROLE; }
-principal                   { if(debug) fprintf(yyout," PRINCIPAL ");
-                              return PRINCIPAL; }
-[a-zA-Z0-9][_a-zA-Z0-9]*    { yylval.string=strdup(yytext); 
-                              if(debug) fprintf(yyout," IDEN ");
-                                return IDEN; }
-\<-                         { if(debug) fprintf(yyout," DERIVE ");
-                                return DERIVE; }
-\.                          { if(debug) fprintf(yyout, " DOT " );
-                                return DOT; }
-&                           { if(debug) fprintf(yyout, " AND " );
-                                return AND; }
-,                           { if(debug) fprintf(yyout, " COMMA ");
-                                return COMMA; }
-\(                          { if(debug) fprintf(yyout, " LPAREN ");
-                                return LPAREN; }
-\)                          { if(debug) fprintf(yyout, " RPAREN ");
-                                return RPAREN; }
-\[                          { if(debug) fprintf(yyout, " LSQUARE ");
-                                return LSQUARE; }
-\]                          { if(debug) fprintf(yyout, " RSQUARE ");
-                                return RSQUARE; }
-\:                          { if(debug) fprintf(yyout, " COLON ");
-                                return COLON; }
-\?                          { if(debug) fprintf(yyout, " QMARK ");
-                                return QMARK; }
-\n                          { /* ignore end-of-line */; }
-[ \t]+                      { /* ignore whitespace */; }
-%%
-
+void abac_yy_push_keyid_state()
+{
+    if(debug) fprintf(yyout, "\n push keyid state\n");
+    yy_push_state(KEYID_S);
+}
+
+void abac_yy_push_range_state()
+{
+    if(debug) fprintf(yyout, "\n push range state\n");
+    yy_push_state(RANGE_S);
+}
+
+char* abac_yy_get_state_string(int t)
+{
+    switch (t) {
+     case BOOLEAN_S: return strdup("boolean");
+     case INTEGER_S: return strdup("integer");
+     case FLOAT_S: return strdup("float");
+     case TIME_S: return strdup("time");
+     case URN_S: return strdup("urn");
+     case STRING_S: return strdup("string");
+     default: return strdup("dumdum");
+   }
+}
+
+void abac_yy_push_state(char *str)
+{
+   if(strcmp(str,"boolean")==0) {
+      if(debug) fprintf(yyout, "\n push boolean state\n");
+      yy_push_state(BOOLEAN_S);
+      return;
+   }
+   if(strcmp(str,"integer")==0) {
+      if(debug) fprintf(yyout, "\n push integer state\n");
+      yy_push_state(INTEGER_S);
+      return;
+   }
+   if(strcmp(str,"float")==0) {
+      if(debug) fprintf(yyout, "\n push float state\n");
+      yy_push_state(FLOAT_S);
+      return;
+   }
+   if(strcmp(str,"time")==0) {
+      if(debug) fprintf(yyout, "\n push time state\n");
+      yy_push_state(TIME_S);
+      return;
+   }
+   if(strcmp(str,"urn")==0) {
+      if(debug) fprintf(yyout, "\n push urn state\n");
+      yy_push_state(URN_S);
+      return;
+   }
+   if(strcmp(str,"string")==0) {
+      if(debug) fprintf(yyout, "\n push string state\n");
+      yy_push_state(STRING_S);
+      return;
+   }
+   
+   if(debug) fprintf(yyout, "eek.. lost in push_state\n");
+}
+
+void abac_yy_pop_state()
+{
+   if(debug) fprintf(yyout, " pop a state\n");
+   yy_pop_state();
+}
